% [wcdf1,wcdf2,wcn] = dfSUREshrink(wcdf1,wcdf2,wcn,minSize,res,FOV,percentZero,sigma)
%
% SUREshrink operator on divergence-free wavelet coefficients
% 
% Inputs: 
%     wcdf1,wcdf2 -   Two divergence-free wavelet coefficients
%     wcn         -   Non-divergence-free wavelet coefficients
%     minSize     -   minimum size for the wavelet scaling subband
%     res         -   resolution (a 1x3 array)
%     FOV         -   image size ( ie size(vx) )
%     percentZero -   percentage of masked out elements in velocity data
%     sigma       -   noise standard deviation
%
% Outputs:
%     wcdf1,wcdf2 -   Two divergence-free wavelet coefficients
%     wcn         -   Non-divergence-free wavelet coefficients
%
%